import java.awt.*;

public class Constrain {
  
  // This is the constrain function from "Java in a Nutshell"
  // This is the main version which needs to have all arguments specified.
  public static void constrain(Container container, Component component,
	      int grid_x, int grid_y, int grid_width, int grid_height,
	      int fill, int anchor, double weight_x, double weight_y,
	      int top, int left, int bottom, int right)
  {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x;  c.gridy = grid_y;
    c.gridwidth = grid_width;  c.gridheight = grid_height;
    c.fill = fill;  c.anchor = anchor;
    c.weightx = weight_x;  c.weighty = weight_y;
    if (top + left + bottom + right > 0)
      c.insets = new Insets(top, left, bottom, right);
    
      ((GridBagLayout)container.getLayout()).setConstraints(component,c);
      container.add(component);
  }
  
  // This version of constrain() positions a component that does
  // not grow and which does not have margins
  public static void constrain(Container container, Component component,
	      int grid_x, int grid_y, int grid_width, int grid_height)
  {
    constrain(container, component, grid_x, grid_y, grid_width, grid_height,
	      GridBagConstraints.NONE, GridBagConstraints.NORTHWEST, 0.0, 0.0,
	      0,0,0,0);
  }
  
  // This versions of constrain() positions a component that does
  // not grow but which does have margins
  public static void constrain(Container container, Component component,
	      int grid_x, int grid_y, int grid_width, int grid_height,
	      int top, int left, int bottom, int right)
  {
    constrain(container, component, grid_x, grid_y, grid_width, grid_height,
	      GridBagConstraints.NONE, GridBagConstraints.WEST, 0.0, 0.0,
	      top, left, bottom, right);
  }
}
