//programed by Tom Busey busey@indiana.edu

import java.applet.Applet;
import java.awt.*;
import java.awt.image.ColorModel;
import java.awt.image.MemoryImageSource;
import java.lang.InterruptedException;
import java.net.URL;
import java.awt.datatransfer.*; 
import java.io.*;
import javax.imageio.*;
import java.io.File;
import java.awt.image.BufferedImage;
import javax.swing.JFileChooser;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;
import javax.swing.JFrame;
import java.util.StringTokenizer;

public class FaceMachine extends Applet implements Runnable {
	
	Thread kicker;
	colorCanvas canvas;
	colorControl lightColor_panel, ambientColor_panel, objectColor_panel,
	diffuseColor_panel, spectalColor_panel;
	colorBar shine_panel, bright_panel;
	Button restart = new Button("New Image");
	miscControls misc_panel;
	byte [] testImageBytes;
	MyGifPixelGrabber m_gifPixelGrabber;
	Image m_image=null;
	Object m_pixelData=null;
	//int[] pixelData;
	byte[] pixelData;
	static int isApplet = 1;
	
	int IV = 5;
	
	double[][] allData;
	Image oldimg;
	double facemeanmin = 0.1192;
	double facemeanmax = 0.7585;
	double [] mins = {-0.0121195830, -0.0073741181, -0.0131040410, -0.0115702780, -0.0128386360, -0.0097013160, -0.0103785260, -0.0123571500, -0.0162174800, -0.0148252820, -0.0210890040, -0.0148383260, -0.0186682950, -0.0157145630, -0.0147583510, -0.0130982120, -0.0176126780, -0.0153503900, -0.0207375100, -0.0210614800};
	double [] maxes = {0.0041030262, 0.0005209417, 0.0162322490, 0.0160221400, 0.0109843630, 0.0147602700, 0.0117781010, 0.0183881120, 0.0136157810, 0.0183597340, 0.0162997100, 0.0168143750, 0.0188312860, 0.0200793510, 0.0232782100, 0.0150145720, 0.0164071990, 0.0196537860, 0.0142010720, 0.0172693600};
	int [] weights = {IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV};
	// int [] oldweights = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	int [] oldweights = {IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV, IV};
	
	double [] currentdata;
	
	public static final int WIDTH = 210;
	public static final int HEIGHT = 240; 
	public static final int NUMFACES = 17;// ave face, 15 eigenfaces, 1 mask
	public static final int NUMEFACES = 15;// ave face, 15 eigenfaces, 1 mask
	public static final int CENTERNUM = 5;// ave face, 15 eigenfaces, 1 mask
	
	
	public void init() {
		String filename;
		
		allData = new double [NUMFACES][WIDTH * HEIGHT];
		currentdata = new double[WIDTH * HEIGHT];
		
		//load images
		
		//m_image=getImage(getCodeBase(), "test.gif");
		for (int imagenum = 0; imagenum < NUMFACES; imagenum++)
		{
			if (imagenum > 0)
			{
				if (imagenum == NUMFACES-1)
					filename = "maskForFeathering10.gif";
					else
						filename = "Eigen"+ Integer.toString(imagenum) + ".gif";  
			}
			else
			{filename = "meanface.gif";}
			
			URL url1 = getClass().getResource(filename);
			m_image= Utilities.blockingLoad(url1);
			
			MediaTracker mediaTracker=new MediaTracker(this);
			mediaTracker.addImage(m_image, 0);
			try
			{
				mediaTracker.waitForID(0); 
			}
			catch (InterruptedException e)
			{
			}
			mediaTracker.removeImage(m_image);
			m_gifPixelGrabber=new MyGifPixelGrabber (m_image);
			m_gifPixelGrabber.grabPixels();
			m_pixelData=m_gifPixelGrabber.getPixels();
			pixelData=(byte[])m_pixelData;
			// allData[imagenum] = new double [200*200];
			for (int index = 0; index < HEIGHT*WIDTH; index++)
			{
				if (pixelData[index]<0)
				{ allData[imagenum][index] =(double)(pixelData[index])+256;}
				else
				{allData[imagenum][index] = (double)(pixelData[index]);}
				if ((imagenum>0)&(imagenum<NUMFACES-1))//last one is mask; don't fix it
				{allData[imagenum][index] = (allData[imagenum][index]/255) * (maxes[imagenum-1] -mins[imagenum-1]) + mins[imagenum-1];}
				else         
				{if (imagenum==0)
					{
						allData[imagenum][index] = (allData[imagenum][index]/255) * (facemeanmax -facemeanmin) + facemeanmin;
						currentdata[index] = allData[imagenum][index];
					}
					else//do mask
					{
						allData[imagenum][index] = (allData[imagenum][index]/255);
					}
				}
			}
		}
		
		//  baseimage is in currentdate. update as necessary
		for (int imagenum = 0; imagenum<NUMEFACES; imagenum++)
		{
			if (weights[imagenum]!=oldweights[imagenum])
			{ 
				for(int index = 0; index < HEIGHT*WIDTH; index++)
				{currentdata[index] = currentdata[index]+ (weights[imagenum]-oldweights[imagenum])*allData[imagenum+1][index]*10;}
				oldweights[imagenum]=weights[imagenum];
			}
		}
		
		FaceMachine fm = this;
		
		setLayout(new GridBagLayout());
		canvas             = new colorCanvas();
		ambientColor_panel = new colorControl("1-3",weights[0], weights[1], weights[2], fm);
		lightColor_panel   = new colorControl("4-6", weights[3], weights[4], weights[5], fm);
		
		objectColor_panel  = new colorControl("7-9", weights[6], weights[7], weights[8], fm);
		diffuseColor_panel = new colorControl("10-12", weights[9], weights[10], weights[11], fm);
		spectalColor_panel = new colorControl("13-15", weights[12], weights[13], weights[14], fm);
		
		misc_panel         = new miscControls(fm, isApplet);
		
		/* The set-up is something like this:
		*
		* AC  LC  Canvas
		* OC  DC  SC mc
		*
		* and it looks like everything has to grow.
		*/
		
		Constrain.constrain(this, ambientColor_panel, 0,0,1,1,
		GridBagConstraints.VERTICAL,
		GridBagConstraints.CENTER,1.0,1.0, 3,3,3,3);
		Constrain.constrain(this, lightColor_panel,   1,0,1,1,
		GridBagConstraints.VERTICAL,
		GridBagConstraints.CENTER,1.0,1.0, 3,3,3,3);
		Constrain.constrain(this, objectColor_panel,  0,1,1,1,
		GridBagConstraints.VERTICAL,
		GridBagConstraints.CENTER,1.0,1.0, 3,3,3,3);
		Constrain.constrain(this, diffuseColor_panel, 1,1,1,1,
		GridBagConstraints.VERTICAL,
		GridBagConstraints.CENTER,1.0,1.0, 3,3,3,3);
		Constrain.constrain(this, spectalColor_panel, 2,1,1,1,
		GridBagConstraints.VERTICAL,
		GridBagConstraints.CENTER,1.0,1.0, 3,3,3,3);
		
		Constrain.constrain(this, misc_panel,        3,1,1,1,
		GridBagConstraints.VERTICAL,
		GridBagConstraints.CENTER,1.0,1.0, 3,3,3,3);
		
		
		Constrain.constrain(this, canvas, 2,0,2,1, GridBagConstraints.BOTH,
		GridBagConstraints.CENTER, 1.0, 1.0, 3,3,3,3);
		
		
	}
	
	public synchronized void start() {
	//	if (canvas.getImage() == null) {
		if (kicker == null) {
			kicker = new Thread(this);
			kicker.start();
		}
	}
	
	public synchronized void stop() {
		try {
			if (kicker != null) {
				kicker.stop();
			}
		} catch (Exception e) {
		}
		kicker = null;
	}
	
	public void restart() {
		if (kicker ==null)//tab added
		{
			stop();
			//canvas.setImage(null);
			//oldimg = canvas.img;
			//canvas.setImage(oldimg);
			//canvas.repaint();
			start();
		}
	}
	
	public static void main(String args[]) {
		JFrame f = new JFrame("The Face Machine");
		FaceMachine faceMachine = new FaceMachine();
		// f.setPreferredSize(new Dimension(400,600));
		isApplet = 0; 
		
		faceMachine.init();
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.getContentPane().add("Center", faceMachine);
		f.pack();
		f.show();
		faceMachine.start();
	}
	
	
	public void saveImage()
	{
		try {
			//File f = new File("myimage.jpg");
			String filename = "Untitled.jpg";
			JFileChooser fc = new JFileChooser(new File(filename));
			fc.showSaveDialog(this);
			File f = fc.getSelectedFile();
			if (f!=null)
			{
				BufferedImage bufferedImage = new BufferedImage(WIDTH, HEIGHT, BufferedImage.TYPE_INT_RGB);
				Graphics2D bufImageGraphics = bufferedImage.createGraphics();
				bufImageGraphics.drawImage(canvas.getImage(), 0, 0, null);
				ImageIO.write(bufferedImage, "jpg", f);  
			}
		}
		catch (IOException e) {e.printStackTrace();}
	}
	public void copyImage()
	{
		setClipboard(canvas.getImage()); 
	}
	
	public static void setClipboard(Image image) {
		ImageSelection imgSel = new ImageSelection(image);
		Toolkit.getDefaultToolkit().getSystemClipboard().setContents(imgSel, null);
	}
	
	public void appendToTextFile () {
		
		BufferedWriter bw = null;
		String coordsToWrite = arrayToString2(weights, "\t");
		
		try {
			bw = new BufferedWriter(new FileWriter("faceCoordinates.txt", true));
			bw.write(coordsToWrite);
			bw.newLine();
			bw.flush();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		} finally {                       // always close the file
			if (bw != null) try {
				bw.close();
			} catch (IOException ioe2) {
				// just ignore it
			}
		} // end try/catch/finally
		
	} // end appendToTextFile()
	//-------------------------------------------------- arrayToString2()
	// Convert an array of strings to one string.
	// Put the 'separator' string between each element.
	
	public static String arrayToString2(int[] a, String separator) {
		StringBuffer result = new StringBuffer();
		if (a.length > 0) {
			result.append(a[0]);
			for (int i=1; i<a.length; i++) {
				result.append(separator);
				result.append(a[i]);
			}
		}
		return result.toString();
	}
	public void resetControls()
	{
		
		
		ambientColor_panel.redbar.setValue(IV);
		ambientColor_panel.greenbar.setValue(IV);
		ambientColor_panel.bluebar.setValue(IV);
		
		lightColor_panel.redbar.setValue(IV);
		lightColor_panel.greenbar.setValue(IV);
		lightColor_panel.bluebar.setValue(IV);
		
		objectColor_panel.redbar.setValue(IV);
		objectColor_panel.greenbar.setValue(IV);
		objectColor_panel.bluebar.setValue(IV);
		
		diffuseColor_panel.redbar.setValue(IV);
		diffuseColor_panel.greenbar.setValue(IV);
		diffuseColor_panel.bluebar.setValue(IV);
		
		spectalColor_panel.redbar.setValue(IV);
		spectalColor_panel.greenbar.setValue(IV);
		spectalColor_panel.bluebar.setValue(IV);
	}
	
	public void randomize(int extent, int base)
	{
		List newvals = pickNumbers( extent, 15, base);
		
		int currentWeight= 0;
		ambientColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		ambientColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		ambientColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		
		lightColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		lightColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		lightColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		
		objectColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		objectColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		objectColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		
		diffuseColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		diffuseColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		diffuseColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		
		spectalColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		spectalColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
		spectalColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
	}
	
	public void loadFace()
	{
		
		JFileChooser m_fileChooser = new JFileChooser();
		String line = new String();
		List newvals = new ArrayList();
		
		int retval = m_fileChooser.showOpenDialog(this);
		if (retval == JFileChooser.APPROVE_OPTION) 
		{
			//... The user selected a file, process it.
			File file = m_fileChooser.getSelectedFile();
			
			//List newvals = pickNumbers( extent, 15, base);
			//List newvals = new List();
			try
			{
				BufferedReader input = new BufferedReader (new FileReader (file));
				if ((line = input.readLine()) != null) {//just read first line
					
					StringTokenizer tokenizer = new StringTokenizer(line); //if space is used to separate the values.
					//System.out.println("tokenizer length = " + tokenizer.countTokens());
					while( tokenizer.hasMoreTokens() ) {
						newvals.add( tokenizer.nextToken() );
						//	System.out.println("newvals = " + newvals);
					}
				}
				//System.out.println("line = " + line);
				//System.out.println("newvals = " + newvals);
				if (newvals.size()==15)
				{
					
					int currentWeight= 0;
					ambientColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					ambientColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					ambientColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					
					lightColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					lightColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					lightColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					
					objectColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					objectColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					objectColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					
					diffuseColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					diffuseColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					diffuseColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					
					spectalColor_panel.redbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					spectalColor_panel.greenbar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
					spectalColor_panel.bluebar.setValue((int)Integer.parseInt(newvals.get(currentWeight++).toString()));
				}
			}
			catch (IOException e) {}
			
		}
		
	}
	
	/**
	* Get a List of random Integers in the range 0 (inclusive) to N (exclusive).
	*
	* @param aUpperLimit must be greater than 0.
	* @param aListSize must be greater than 0.
	* @exception IllegalArgumentException if param does not comply.
	
	base is added to each number
	*/
	public List pickNumbers( int aUpperLimit, int aListSize, int base ) {
		if (aUpperLimit <=0) {
			throw new IllegalArgumentException("UpperLimit must be positive: " + aUpperLimit);
		}
		if (aListSize <=0) {
			throw new IllegalArgumentException("Size of returned List must be greater than 0.");
		}
		//reuse one and the same Random object to generate a series
		//of random Integers
		Random generator = new Random();
		List result = new ArrayList();
		for( int idx=0; idx<aListSize; ++idx) {
			result.add(new Integer(generator.nextInt(aUpperLimit)+base));
		}
		return result;
	}
	
	
	
	
	public void run() {
		Thread me = Thread.currentThread();  me.setPriority(4);
		int width = canvas.size().width;
		int height = canvas.size().height;
		
		width = WIDTH;
		height = HEIGHT;
		
		int pixels[] = new int[width * height];
		
		// for (int index = 0; index<width*height; index++)
		//               pixels[index] =  (255<< 24) | (255 << 16) | (255 << 8) | 255;
		System.out.println("in run");
		int index = 0;
		
		//  if (doingmath == 0)
		{
			
			
			int curweight = 0;
			
			weights[curweight++] = ambientColor_panel.redbar.value;
			weights[curweight++] = ambientColor_panel.greenbar.value;
			weights[curweight++] = ambientColor_panel.bluebar.value;
			
			weights[curweight++] = lightColor_panel.redbar.value;
			weights[curweight++] = lightColor_panel.greenbar.value;
			weights[curweight++] = lightColor_panel.bluebar.value;
			
			weights[curweight++] = objectColor_panel.redbar.value;
			weights[curweight++] = objectColor_panel.greenbar.value;
			weights[curweight++] = objectColor_panel.bluebar.value;
			
			weights[curweight++] = diffuseColor_panel.redbar.value;
			weights[curweight++] = diffuseColor_panel.greenbar.value;
			weights[curweight++] = diffuseColor_panel.bluebar.value;
			
			weights[curweight++] = spectalColor_panel.redbar.value;
			weights[curweight++] = spectalColor_panel.greenbar.value;
			weights[curweight++] = spectalColor_panel.bluebar.value;
			
			//  baseimage is in currentdate. update as necessary
			for (int imagenum = 0; imagenum<NUMEFACES; imagenum++)
			{
				if (weights[imagenum]!=oldweights[imagenum])
				{ 
					for( index = 0; index < HEIGHT*WIDTH; index++)
					{currentdata[index] = currentdata[index]+ (weights[imagenum]-oldweights[imagenum])*allData[imagenum+1][index]*10;}
					oldweights[imagenum]=weights[imagenum];
				}
			}
			double currentmin = 1000;
			double currentmax  = -1000;
			//double currentsum = 0.0;
			//double currentsumsqr = 0.0;
			//double currentN = 0.0;
			for (index = 0; index<HEIGHT*WIDTH; index++)
			{
				if (allData[16][index]>0.5)
				{
					if (currentdata[index]>currentmax)
					{currentmax = currentdata[index];}
					
					if (currentdata[index]<currentmin)
					{currentmin = currentdata[index];}
				//	currentsum += currentdata[index];
					//currentsumsqr += currentdata[index]*currentdata[index];
					//currentN += 1;
				}
			}
			//double currentmean = currentsum / currentN;
			//double currentSD = (currentsumsqr - ((currentsum * currentsum)/currentN))/(currentN-1);
			//System.out.println("Current mean = " + currentmean + " currentSD = " + currentSD);
			if (1==2)
			{
				index = 0;
				for (int y1 = 0; y1 < height; y1++)
				{
					for (int x1 = 0; x1 < width; x1++)
					{
						//   int red = 255-(int)Math.round(((allData[16][index]/255))*(((255-allData[0][index]) * ((double)light_color[0]/255))));
						double reddouble = ((currentdata[index]-currentmin)/(currentmax-currentmin))*255;
						int red = 255-(int)Math.round(allData[16][index]*(255-reddouble));
						if (red > 255)
						{red = 255;}
						if (red<0)
						{red =0;}
						
						pixels[index++] =  (255<< 24) | (red << 16) | (red << 8) | red;
					}
				}
			}
			else
			{
				index = 0;
				int canvasy = 0;
				int canvasx = 0;
				for (int y1 = 0; y1 < height; y1++) 
				{
					for (int x1 = 0; x1 < width; x1++) 
					{
						if ((y1<HEIGHT)&(x1<WIDTH))
						{
							//   int red = 255-(int)Math.round(((allData[16][index]/255))*(((255-allData[0][index]) * ((double)light_color[0]/255))));
							double reddouble = ((currentdata[y1*WIDTH+x1]-currentmin)/(currentmax-currentmin))*255;//spread out as much as possible
							//double reddouble = (((currentdata[y1*WIDTH+x1]-currentmean)/(currentSD))*3)+128;//fix variance
							//if ((x1 == 100)&(y1 == 100))
							//	System.out.println("reddouble = " + reddouble);

							int red = 255-(int)Math.round(allData[16][y1*WIDTH+x1]*(255-reddouble));
							if (red > 255)
							{red = 255;}
							if (red<0)
							{red =0;}
							if ((y1<height)&(x1<width))
								pixels[y1*width+x1] =  (255<< 24) | (red << 16) | (red << 8) | red;
						}
					}
				}
				
			}

			newImage(me, width, height, pixels);
			canvas.repaint();
			if (canvas.getImage() != null)
				oldimg = canvas.getImage();
				System.out.println("oldimg = " + oldimg);
				
		}
	}
	
	synchronized void newImage(Thread me, int width, int height, int pixels[])
	{
						System.out.println("in newimage");

		if (kicker != me) {
			return;
		}
							System.out.println("after run");

		Image img;
		img = createImage(new MemoryImageSource(width, height,
		ColorModel.getRGBdefault(),
		pixels, 0, width));
		canvas.setImage(img);
							System.out.println("after setimage. Image = "+ img);

		// oldimg = img;
		kicker = null;
	}
}

class colorCanvas extends Canvas {
	Image img;
	Image oldimg;
	Image buffer;                    // The off-screen image for double-buffering
	Graphics bufferGraphics;         // A Graphics object for the buffer
	
	public void paint(Graphics g) {
		int w = size().width;
		int h = size().height;
		
		if (buffer == null)
		{
			System.out.println("Buffer is null!");
			buffer = this.createImage(w, h);
			bufferGraphics = buffer.getGraphics();
		}
		if (img == null) {
					System.out.println("image is null!");

			/* super.paint(g);
			g.setColor(Color.black);
			FontMetrics fm = g.getFontMetrics();
			int x = (w - fm.stringWidth(calcString))/2;
			int y = h/2;
			g.drawString(calcString, x, y);*/
			if (oldimg!=null)
				bufferGraphics.drawImage(oldimg, 0, 0, w, h, this);
		} else {
			bufferGraphics.drawImage(img, 0, 0, w, h, this);
			oldimg = img;
		}
		g.drawImage(buffer, 0, 0, this);
		
	}
	
	/** Don't clear the screen; just call paint() immediately
	*   It is important to override this method like this for double-buffering */
	public void update(Graphics g) { paint(g); }
	
	
	public Dimension minimumSize() {
		return new Dimension(210, 240);
	}
	
	public Dimension preferredSize() {
		return new Dimension(210,240);
	}
	
	public Dimension maximumSize() {
		return new Dimension(210,240);
	}
	
	public Image getImage() {
		return img;
	}
	
	public void setImage(Image img) {
		this.img = img;
		System.out.println("img in setImage = " + img);
		repaint();
	}
	
	
}

/** A colorControl has three sliders (ie colorBars) which control one
*  of the basic colors associated with a Phong model.  It only has 
*  a constructor.
*/

class colorControl extends Panel {
	colorBar redbar, greenbar, bluebar;
	static FaceMachine applet;
	public colorControl() {
		this("Unknown",0,0,0, null);
	}
	
	public colorControl(String title, int r, int g, int b, FaceMachine app) {
		redbar = new colorBar(".",r, app);    
		greenbar = new colorBar(".",b, app);
		bluebar = new colorBar(".",g, app);
		
		
		setLayout(new BorderLayout());
		Label title_label = new Label(title, Label.CENTER);
		add("North",title_label);
		Panel sliders = new Panel();
		sliders.setLayout(new GridLayout(1,0));
		sliders.add(redbar);
		sliders.add(greenbar);
		sliders.add(bluebar);
		add("Center",sliders);
	}
	
	
	public Dimension minimumSize() {
		return new Dimension(100, 240);
	}
	
	public Dimension preferredSize() {
		return new Dimension(100,240);
	}
	
	
	public boolean action(Event evt, Object arg) {
		return false;
	}
}

/** A colorBar is a scrollbar with a label on top and a value indicator 
*  beneath it.  It only has a constructor and event handler for when the
*  slider (scrollbar) is moved.
*/

class colorBar extends Panel {
	Label value_label, label;
	Scrollbar slider;
	int value;
	static FaceMachine applet;
	
	// static final int LINEAR = 0;
	// static final int LOG = 1;
	private float sb_min, sb_max;
	
	// TextField value;
	
	public colorBar( String color, int initial , FaceMachine app) {
		this( color, initial, 1, 10, app);
	}
	
	public colorBar(String color, int initial, float min, float max, FaceMachine app) {
		applet = app; 
		
		value_label = new Label( String.valueOf(10- initial ), Label.CENTER );
		
		label = new Label( color, Label.CENTER );
		
		value = initial;
		
		//   slider = new Scrollbar( Scrollbar.VERTICAL, (int) (max - initial),
		//                        (int)( max - min ) / 10,
		//                      (int)min, (int)max + (int)( max - min ) / 10 );
		slider = new Scrollbar( Scrollbar.VERTICAL, initial, 1, (int)min, (int)max);
		
		sb_min = min; sb_max = max;
		
		GridBagLayout gridbag = new GridBagLayout();
		setLayout(gridbag);
		Constrain.constrain(this, label,       0,0,1,1,   1,0,1,0);
		Constrain.constrain(this, slider, 0,1,1,1,GridBagConstraints.VERTICAL,
		GridBagConstraints.CENTER,0.0,1.0,1,2,1,2);
		Constrain.constrain(this, value_label, 0,2,1,1,   1,0,1,0);
	}
	
	public void setValue(int theValue){
		String tempStrn;
		
		slider.setValue(theValue);
		value = slider.getValue();
		tempStrn = String.valueOf(10- value );
		// if ( tempStrn.length() > 3 )
		// tempStrn = tempStrn.substring( 0 , 3 );
		value_label.setText( tempStrn );
		
	}
	
	public boolean handleEvent(Event evt) {
		String tempStrn;
		
		if ( evt.target == slider ) {
			//      value = (int)( sb_max - slider.getValue() + sb_min );
			value = (int)( slider.getValue() );
			tempStrn = String.valueOf( 10-value );
			// if ( tempStrn.length() > 3 )
			// tempStrn = tempStrn.substring( 0 , 3 );
			value_label.setText( tempStrn );
			if (applet!=null)
				applet.restart();
				return true;
		}
		return false;
	}
}

/** The miscControls is essentially a panel for all of the "extra" stuff
*  that doesn't seem to fit anyplace else.  It is built by varying the
*  colorControls class.
*/

class miscControls extends Panel {
	Button saveImage;
	Button copyImage;
	Button reset;
	Button random;
	Button smallrandom;
	Button info;
	Button tinyrandom;
	Button appendText;
	Button loadFace;
	static FaceMachine applet;
	int ourisApplet;
	
	public miscControls(FaceMachine app, int isApplet) {
		saveImage = new Button("Save Image");
		copyImage = new Button("Copy Image"); 
		reset = new Button("Reset");
		random = new Button("Random");
		smallrandom = new Button("Small Rand");
		info = new Button("Info");
		tinyrandom = new Button("Tiny Rand");
		appendText = new Button("Append Coords");
		loadFace = new Button("Load Face");
		ourisApplet = isApplet;
		
		applet = app;
		setLayout(new BorderLayout());
		Panel sliders1 = new Panel();
		sliders1.setLayout(new GridLayout(0,1,10,0));
		if (ourisApplet == 0)
		{
			sliders1.add(saveImage);
			sliders1.add( copyImage );
		}
		sliders1.add(reset);
		sliders1.add( random );
		sliders1.add( smallrandom );
		sliders1.add( tinyrandom );
		sliders1.add( appendText );
		sliders1.add( loadFace );
		
		// Panel sliders2 = new Panel();
		//sliders2.setLayout(new GridLayout(0,1,10,0));
		sliders1.add(info);
		//  sliders1.add( about );
		
		add("Center", sliders1);
		// add("South", sliders2);
		
	}
	
	public boolean action(Event evt, Object arg) {
		
		if (evt.target == copyImage) {
			applet.copyImage();
			return true;
		}
		if (evt.target == saveImage) {
			applet.saveImage();
			return true;
		}
		if (evt.target == reset) {
			applet.resetControls();
			applet.restart();
			
			return true;
		}
		if (evt.target == random) {
			applet.randomize(9, 1);
			applet.restart();
			
			return true;
		}
		if (evt.target == smallrandom) {
			applet.randomize(5, 3 );
			applet.restart();
			
			return true;
		}
		if (evt.target == tinyrandom) {
			applet.randomize(3, 4 );
			applet.restart();
			
			return true;
		}
		if (evt.target == appendText) {
			applet.appendToTextFile();
			//applet.restart();
			
			return true;
		}
		if (evt.target == loadFace) {
			applet.loadFace();
			applet.restart();
			
			return true;
		}
		if (evt.target == info)
		{
			tabbedPane tabbedPane =  new tabbedPane();
			JFrame f = new JFrame();
			f.getContentPane().add(tabbedPane);
			f.setSize(800, 580);
			f.setVisible(true);
			
			
		}
		
		return false;
	}
}
